diff -ruN linux-2.6.7/arch/i386/kernel/entry.S linux-2.6.7-dcl/arch/i386/kernel/entry.S
--- linux-2.6.7/arch/i386/kernel/entry.S	2004-07-11 00:01:26.000000000 -0600
+++ linux-2.6.7-dcl/arch/i386/kernel/entry.S	2004-07-11 00:03:22.000000000 -0600
@@ -886,5 +886,6 @@
 	.long sys_mq_notify
 	.long sys_mq_getsetattr
 	.long sys_ni_syscall		/* reserved for kexec */
+	.long sys_disablenetwork
 
 syscall_table_size=(.-sys_call_table)
diff -ruN linux-2.6.7/include/asm-i386/unistd.h linux-2.6.7-dcl/include/asm-i386/unistd.h
--- linux-2.6.7/include/asm-i386/unistd.h	2004-07-11 00:01:43.000000000 -0600
+++ linux-2.6.7-dcl/include/asm-i386/unistd.h	2004-07-11 00:04:26.000000000 -0600
@@ -289,8 +289,9 @@
 #define __NR_mq_notify		(__NR_mq_open+4)
 #define __NR_mq_getsetattr	(__NR_mq_open+5)
 #define __NR_sys_kexec_load	283
+#define __NR_disablenetwork	284
 
-#define NR_syscalls 284
+#define NR_syscalls 285
 
 /* user-visible error numbers are in the range -1 - -124: see <asm-i386/errno.h> */
 
diff -ruN linux-2.6.7/include/linux/sched.h linux-2.6.7-dcl/include/linux/sched.h
--- linux-2.6.7/include/linux/sched.h	2004-07-11 00:01:53.000000000 -0600
+++ linux-2.6.7-dcl/include/linux/sched.h	2004-07-11 00:05:45.000000000 -0600
@@ -508,6 +508,7 @@
 
 	unsigned long ptrace_message;
 	siginfo_t *last_siginfo; /* For ptrace use.  */
+	int network_disabled; /* for disablenetwork() syscall */
 
 #ifdef CONFIG_NUMA
   	struct mempolicy *mempolicy;
diff -ruN linux-2.6.7/net/socket.c linux-2.6.7-dcl/net/socket.c
--- linux-2.6.7/net/socket.c	2004-07-11 00:02:01.000000000 -0600
+++ linux-2.6.7-dcl/net/socket.c	2004-07-11 00:08:37.000000000 -0600
@@ -1127,6 +1127,9 @@
 	int retval;
 	struct socket *sock;
 
+	if (current->network_disabled && family != AF_UNIX)
+		return -EACCES;
+	
 	retval = sock_create(family, type, protocol, &sock);
 	if (retval < 0)
 		goto out;
@@ -1227,6 +1230,8 @@
 	if((sock = sockfd_lookup(fd,&err))!=NULL)
 	{
 		if((err=move_addr_to_kernel(umyaddr,addrlen,address))>=0) {
+			if (current->network_disabled && ((struct sockaddr *)address)->sa_family != AF_UNIX)
+				return -EACCES;
 			err = security_socket_bind(sock, (struct sockaddr *)address, addrlen);
 			if (err) {
 				sockfd_put(sock);
@@ -1365,6 +1370,9 @@
 	if (err < 0)
 		goto out_put;
 
+	if (current->network_disabled && ((struct sockaddr *)address)->sa_family != AF_UNIX)
+		return -EACCES;
+
 	err = security_socket_connect(sock, (struct sockaddr *)address, addrlen);
 	if (err)
 		goto out_put;
@@ -1465,6 +1473,9 @@
 		err = move_addr_to_kernel(addr, addr_len, address);
 		if (err < 0)
 			goto out_put;
+		if (current->network_disabled && ((struct sockaddr *) address)->sa_family != AF_UNIX)
+			return -EACCES;
+
 		msg.msg_name=address;
 		msg.msg_namelen=addr_len;
 	}
@@ -2024,6 +2035,11 @@
 }
 #endif /* CONFIG_PROC_FS */
 
+asmlinkage void sys_disablenetwork(void)
+{
+	current->network_disabled = 1;
+}
+
 /* ABI emulation layers need these two */
 EXPORT_SYMBOL(move_addr_to_kernel);
 EXPORT_SYMBOL(move_addr_to_user);
